## mrgingham 1.20

=== Makefile ===
PYTHON_VERSION_FOR_EXTENSIONS := 3

include Makefile.common.header


PROJECT_NAME := mrgingham
ABI_VERSION  := 2
TAIL_VERSION := 1


DIST_BIN := mrgingham mrgingham-observe-pixel-uncertainty
DIST_MAN := $(addsuffix .1,$(DIST_BIN))

# I want the tool I ship to be called "mrgingham", but I already have
# mrgingham.cc: it's a part of the LIBRARY
mrgingham: mrgingham-from-image
	cp $< $@
EXTRA_CLEAN += mrgingham
all: mrgingham

BIN_SOURCES := mrgingham-from-image.cc
BIN_SOURCES += test-dump-chessboard-corners.cc test-dump-blobs.cc test-find-grid-from-points.cc

LIB_SOURCES := find_grid.cc find_blobs.cc find_chessboard_corners.cc mrgingham.cc ChESS.c

# The opencv people (or maybe the Debian people?) have renamed the opencv.pc
# file in opencv 4. So now I look for both version 4 and the default. What will
# happen with opencv5? We'll see!
CXXFLAGS_CV := $(shell pkg-config --cflags opencv4 2>/dev/null || pkg-config --cflags opencv 2>/dev/null)
LDLIBS_CV   := $(shell pkg-config --libs   opencv4 2>/dev/null || pkg-config --libs   opencv 2>/dev/null)
CCXXFLAGS += $(CXXFLAGS_CV)
LDLIBS    += $(LDLIBS_CV) -lpthread

CCXXFLAGS += -fvisibility=hidden

CFLAGS    += -std=gnu99
CCXXFLAGS += -Wno-unused-function -Wno-missing-field-initializers -Wno-unused-parameter -Wno-strict-aliasing -Wno-int-to-pointer-cast -Wno-unused-variable

# On opencv4 I do this:
ifneq ($(wildcard /usr/include/opencv4),)
CCXXFLAGS += -D CV_LOAD_IMAGE_GRAYSCALE=cv::IMREAD_GRAYSCALE
endif


DIST_INCLUDE := mrgingham.hh point.hh

# I construct the README.org from the template. The only thing I do is to insert
# the manpages. Note that this is more complicated than it looks:
#
# 1. The documentation lives in a POD
# 2. This documentation is stripped out here with pod2text, and included in the
#    README. This README is an org-mode file, and the README.template.org
#    container included the manpage text inside a #+BEGIN_EXAMPLE/#+END_EXAMPLE.
#    So the manpages are treated as a verbatim, unformatted text blob
# 3. Further down, the same POD is converted to a manpage via pod2man
define MAKE_README =
BEGIN									\
{									\
  for $$a (@ARGV)							\
  {									\
    $$base = $$a =~ s/\.pod$$//r;                                       \
    $$c{$$base} = `pod2text $$a | mawk "/REPOSITORY/{exit} {print}"`;	\
  }									\
}									\
									\
while(<STDIN>)								\
{									\
  print s/xxx-manpage-(.*?)-xxx/$$c{$$1}/gr;				\
}
endef

README.org: README.template.org $(DIST_BIN:%=%.pod)
	< $(filter README%,$^) perl -e '$(MAKE_README)' $(filter-out README%,$^) > $@
all: README.org

%.1: %.pod
	pod2man --center="mrgingham: chessboard corner finder" --name=MRGINGHAM --release="mrgingham $(VERSION)" --section=1 $^ $@
mrgingham-observe-pixel-uncertainty.pod: %.pod: %
	./make-pod.pl $< > $@
	cat footer.pod >> $@
EXTRA_CLEAN += *.1 mrgingham-observe-pixel-uncertainty.pod README.org

########## python stuff

# In the python api I have to cast a PyCFunctionWithKeywords to a PyCFunction,
# and the compiler complains. But that's how Python does it! So I tell the
# compiler to chill
mrgingham_pywrap.o: CFLAGS += -Wno-cast-function-type

mrgingham_pywrap.o: CCXXFLAGS += $(PY_MRBUILD_CFLAGS)
mrgingham_pywrap_cplusplus_bridge.o: CCXXFLAGS += -fPIC
mrgingham_pywrap.o: $(addsuffix .h,$(wildcard *.docstring))

# The python library is called "mrgingham.so". This is confusing, but is the
# best I could do. Because I want to be able to "import mrgingham"; and the
# normal way of creating a "mrgingham" subdirectory for all the python stuff
# doesn't work here: I already have a directory entry called "mrgingham"; it's
# the main commandline tool.
mrgingham$(PY_EXT_SUFFIX): mrgingham_pywrap.o mrgingham_pywrap_cplusplus_bridge.o libmrgingham.so
	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $^ -o $@

DIST_PY3_MODULES := mrgingham$(PY_EXT_SUFFIX)

all: mrgingham$(PY_EXT_SUFFIX)

include Makefile.common.footer

=== debian/changelog ===
mrgingham (1.20-5build1) kinetic; urgency=medium

  * No-change rebuild against libopencv-core406

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Jul 2022 06:19:03 +0000

mrgingham (1.20-5) unstable; urgency=medium

  * Build works with python3.10 (Closes: #1008746)

 -- Dima Kogan <dkogan@debian.org>  Sat, 02 Apr 2022 12:21:14 -0700

mrgingham (1.20-4) unstable; urgency=medium

  * Building for ALL the available Python versions (Closes: #1001764)

 -- Dima Kogan <dkogan@debian.org>  Tue, 21 Dec 2021 11:20:53 -0800

mrgingham (1.20-3) unstable; urgency=medium

  * Build-Depends: libpython3-all-dev -> libpython3-dev (Closes: #999832)

 -- Dima Kogan <dkogan@debian.org>  Fri, 19 Nov 2021 18:03:39 -0800

mrgingham (1.20-2) unstable; urgency=medium

  * Removed the symbols file. Bug fix: "symbols files need updates for
    various architectures", thanks to Matthias Klose (Closes: #999481).

 -- Dima Kogan <dkogan@debian.org>  Fri, 12 Nov 2021 11:24:35 -0800

mrgingham (1.20-1) unstable; urgency=medium

  * Initial release into Debian (Closes: #998794)

 -- Dima Kogan <dkogan@debian.org>  Mon, 08 Nov 2021 12:56:09 -0800

=== debian/control ===
Source: mrgingham
Priority: optional
Section: devel
Build-Depends: debhelper-compat (= 13), dh-python,
 libopencv-dev,
 libboost-dev,
 pkg-config,
 chrpath,
 python3-all, python3-all-dev,
 perl,
 mawk,
 python3-numpy
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 3.9.8
Homepage: https://github.com/dkogan/mrgingham/
Vcs-Git: https://salsa.debian.org/science-team/mrgingham.git
Vcs-Browser: https://salsa.debian.org/science-team/mrgingham
Testsuite: autopkgtest-pkg-python

Package: libmrgingham2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Chessboard finder for visual calibration routines
 Given an observed image containing a chessboard or a grid of circles, mrgingham
 locates the board in the image, and precisely computes the location of the
 chessboard corners (or circle centers). This is similar to the routines in
 OpenCV, but is faster and more robust.
 .
 This package provides the runtime C++ libraries

Package: mrgingham
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmrgingham2 (= ${binary:Version}),
  python3-vnlog,
  python3-numpysane,
  python3-gnuplotlib,
  python3:any
Description: Chessboard finder for visual calibration routines
 Given an observed image containing a chessboard or a grid of circles, mrgingham
 locates the board in the image, and precisely computes the location of the
 chessboard corners (or circle centers). This is similar to the routines in
 OpenCV, but is faster and more robust.
 .
 This package provides the user-facing tools

Package: libmrgingham-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmrgingham2 (= ${binary:Version})
Description: Chessboard finder for visual calibration routines
 Given an observed image containing a chessboard or a grid of circles, mrgingham
 locates the board in the image, and precisely computes the location of the
 chessboard corners (or circle centers). This is similar to the routines in
 OpenCV, but is faster and more robust.
 .
 This package provides the development C++ libraries

Package: python3-mrgingham
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmrgingham2 (= ${binary:Version}),
         ${python3:Depends}
Provides: ${python3:Provides}
Description: Chessboard finder for visual calibration routines
 Given an observed image containing a chessboard or a grid of circles, mrgingham
 locates the board in the image, and precisely computes the location of the
 chessboard corners (or circle centers). This is similar to the routines in
 OpenCV, but is faster and more robust.
 .
 This package provides the Python interfaces

## mrgingham 1.22

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,4 @@
-PYTHON_VERSION_FOR_EXTENSIONS := 3
-
-include Makefile.common.header
+include mrbuild/Makefile.common.header
 
 
 PROJECT_NAME := mrgingham
@@ -8,7 +6,7 @@
 TAIL_VERSION := 1
 
 
-DIST_BIN := mrgingham mrgingham-observe-pixel-uncertainty
+DIST_BIN := mrgingham mrgingham-observe-pixel-uncertainty mrgingham-rotate-corners
 DIST_MAN := $(addsuffix .1,$(DIST_BIN))
 
 # I want the tool I ship to be called "mrgingham", but I already have
@@ -42,13 +40,18 @@
 endif
 
 
+test:
+	test/test--mrgingham-rotate-corners
+.PHONY: test
+
+
 DIST_INCLUDE := mrgingham.hh point.hh
 
 # I construct the README.org from the template. The only thing I do is to insert
 # the manpages. Note that this is more complicated than it looks:
 #
-# 1. The documentation lives in a POD
-# 2. This documentation is stripped out here with pod2text, and included in the
+# 1. The documentation is extracted into a .pod by make-pod-from-help.pl
+# 2. This documentation is stripped out here wih pod2text, and included in the
 #    README. This README is an org-mode file, and the README.template.org
 #    container included the manpage text inside a #+BEGIN_EXAMPLE/#+END_EXAMPLE.
 #    So the manpages are treated as a verbatim, unformatted text blob
@@ -75,10 +78,17 @@
 
 %.1: %.pod
 	pod2man --center="mrgingham: chessboard corner finder" --name=MRGINGHAM --release="mrgingham $(VERSION)" --section=1 $^ $@
-mrgingham-observe-pixel-uncertainty.pod: %.pod: %
-	./make-pod.pl $< > $@
-	cat footer.pod >> $@
-EXTRA_CLEAN += *.1 mrgingham-observe-pixel-uncertainty.pod README.org
+%.pod: %
+	mrbuild/make-pod-from-help.pl $< > $@.tmp
+	cat footer.pod >> $@.tmp
+	mv $@.tmp $@
+EXTRA_CLEAN += *.1 $(addsuffix .pod,$(DIST_BIN)) README.org
+
+%.usage.h: %.usage
+	< $^ sed 's/\\/\\\\/g; s/"/\\"/g; s/^/"/; s/$$/\\n"/;' > $@
+EXTRA_CLEAN += *.usage.h
+
+mrgingham-from-image.o: mrgingham.usage.h
 
 ########## python stuff
 
@@ -103,4 +113,4 @@
 
 all: mrgingham$(PY_EXT_SUFFIX)
 
-include Makefile.common.footer
+include mrbuild/Makefile.common.footer

=== debian/changelog ===
mrgingham (1.22-1) unstable; urgency=medium

  * New upstream release: mrgingham-rotate-corners tool

 -- Dima Kogan <dkogan@debian.org>  Thu, 22 Sep 2022 16:46:25 -0700

mrgingham (1.21-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Tue, 13 Sep 2022 19:41:24 -0700

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,12 @@
  python3-all, python3-all-dev,
  perl,
  mawk,
+# for the tests
+ zsh,
+# for mrgingham-rotate-corners (its tests)
+ vnlog,
  python3-numpy
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
 Standards-Version: 3.9.8
 Homepage: https://github.com/dkogan/mrgingham/
@@ -38,7 +41,9 @@
   python3-vnlog,
   python3-numpysane,
   python3-gnuplotlib,
-  python3:any
+  python3:any,
+# for mrgingham-rotate-corners
+  vnlog
 Description: Chessboard finder for visual calibration routines
  Given an observed image containing a chessboard or a grid of circles, mrgingham
  locates the board in the image, and precisely computes the location of the

## mrgingham 1.24

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,6 @@
-include mrbuild/Makefile.common.header
+include choose_mrbuild.mk
+include $(MRBUILD_MK)/Makefile.common.header
+
 
 
 PROJECT_NAME := mrgingham
@@ -50,7 +52,7 @@
 # I construct the README.org from the template. The only thing I do is to insert
 # the manpages. Note that this is more complicated than it looks:
 #
-# 1. The documentation is extracted into a .pod by make-pod-from-help.pl
+# 1. The documentation is extracted into a .pod by make-pod-from-help
 # 2. This documentation is stripped out here wih pod2text, and included in the
 #    README. This README is an org-mode file, and the README.template.org
 #    container included the manpage text inside a #+BEGIN_EXAMPLE/#+END_EXAMPLE.
@@ -79,7 +81,7 @@
 %.1: %.pod
 	pod2man --center="mrgingham: chessboard corner finder" --name=MRGINGHAM --release="mrgingham $(VERSION)" --section=1 $^ $@
 %.pod: %
-	mrbuild/make-pod-from-help.pl $< > $@.tmp
+	$(MRBUILD_BIN)/make-pod-from-help $< > $@.tmp
 	cat footer.pod >> $@.tmp
 	mv $@.tmp $@
 EXTRA_CLEAN += *.1 $(addsuffix .pod,$(DIST_BIN)) README.org
@@ -89,6 +91,16 @@
 EXTRA_CLEAN += *.usage.h
 
 mrgingham-from-image.o: mrgingham.usage.h
+
+########## chessboard-generating rules
+########## I can "make chessboard.10x14.pdf" and it'll do the right thing
+chessboard.%.fig: generate-chessboard-fig.py
+	./$< $(subst x, ,$*) > $@.tmp
+	mv $@.tmp $@
+%.pdf: %.fig
+	fig2dev -L pdf $< > $@.tmp
+	mv $@.tmp $@
+
 
 ########## python stuff
 
@@ -101,16 +113,17 @@
 mrgingham_pywrap_cplusplus_bridge.o: CCXXFLAGS += -fPIC
 mrgingham_pywrap.o: $(addsuffix .h,$(wildcard *.docstring))
 
-# The python library is called "mrgingham.so". This is confusing, but is the
+# The python library is called "mrgingham.$(SO)". This is confusing, but is the
 # best I could do. Because I want to be able to "import mrgingham"; and the
 # normal way of creating a "mrgingham" subdirectory for all the python stuff
 # doesn't work here: I already have a directory entry called "mrgingham"; it's
 # the main commandline tool.
-mrgingham$(PY_EXT_SUFFIX): mrgingham_pywrap.o mrgingham_pywrap_cplusplus_bridge.o libmrgingham.so
+mrgingham$(PY_EXT_SUFFIX): mrgingham_pywrap.o mrgingham_pywrap_cplusplus_bridge.o libmrgingham.$(SO)
 	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $^ -o $@
 
 DIST_PY3_MODULES := mrgingham$(PY_EXT_SUFFIX)
 
 all: mrgingham$(PY_EXT_SUFFIX)
 
-include mrbuild/Makefile.common.footer
+include $(MRBUILD_MK)/Makefile.common.footer
+

=== debian/changelog ===
mrgingham (1.24-1ubuntu1) noble; urgency=medium

  * d/patches/pkg-config-numpy.patch: Use pkg-config to find numpy headers.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 11 Apr 2024 14:00:42 +1200

mrgingham (1.24-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:10:25 +0000

mrgingham (1.24-1build2) noble; urgency=high

  * No change rebuild against libopencv-features2d406t64, libopencv-
    core406t64, libopencv-imgcodecs406t64, libopencv-imgproc406t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:41:57 +0100

mrgingham (1.24-1build1) noble; urgency=medium

  * No-change rebuild to build with python3.12 as supported.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 02 Nov 2023 19:23:44 +0100

mrgingham (1.24-1) unstable; urgency=medium

  * New upstream release
    - blob detector can find smaller circles
    - Python API: renamed functions (previous ones remain, for
      compatibility). New functions are find_board() and
      find_points()
    - Python API: find_board() and find_points() can find blobs

 -- Dima Kogan <dkogan@debian.org>  Thu, 28 Sep 2023 23:35:20 -0700

mrgingham (1.23-1) unstable; urgency=medium

  * New upstream release
    - bug fix in the Python API: find_chessboard() returns proper output

 -- Dima Kogan <dkogan@debian.org>  Wed, 30 Aug 2023 12:56:47 -0700

mrgingham (1.22.1-1) unstable; urgency=medium

  * New upstream release
    - Minor build updates for old distros

 -- Dima Kogan <dkogan@debian.org>  Tue, 27 Sep 2022 00:41:51 -0700

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: mrgingham
 Priority: optional
 Section: devel
-Build-Depends: debhelper-compat (= 13), dh-python,
+Build-Depends: debhelper (>= 11), dh-python,
  libopencv-dev,
  libboost-dev,
  pkg-config,
+ mrbuild,
  chrpath,
  python3-all, python3-all-dev,
  perl,
@@ -12,9 +13,10 @@
 # for the tests
  zsh,
 # for mrgingham-rotate-corners (its tests)
- vnlog,
+ vnlog (>= 1.33),
  python3-numpy
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
 Standards-Version: 3.9.8
 Homepage: https://github.com/dkogan/mrgingham/
@@ -43,7 +45,7 @@
   python3-gnuplotlib,
   python3:any,
 # for mrgingham-rotate-corners
-  vnlog
+  vnlog (>= 1.33)
 Description: Chessboard finder for visual calibration routines
  Given an observed image containing a chessboard or a grid of circles, mrgingham
  locates the board in the image, and precisely computes the location of the

## mrgingham 1.25

=== debian/changelog ===
mrgingham (1.25-1) unstable; urgency=medium

  * New upstream release (Closes: #1098892)

 -- Dima Kogan <dkogan@debian.org>  Fri, 07 Mar 2025 15:38:26 -0800

mrgingham (1.24-2) unstable; urgency=medium

  * Added Build-Depends:python3-setuptools (Closes: #1080938)

 -- Dima Kogan <dkogan@debian.org>  Thu, 05 Sep 2024 19:14:48 -0700

## mrgingham 1.26

=== Makefile ===
--- 
+++ 
@@ -104,11 +104,6 @@
 
 ########## python stuff
 
-# In the python api I have to cast a PyCFunctionWithKeywords to a PyCFunction,
-# and the compiler complains. But that's how Python does it! So I tell the
-# compiler to chill
-mrgingham_pywrap.o: CFLAGS += -Wno-cast-function-type
-
 mrgingham_pywrap.o: CCXXFLAGS += $(PY_MRBUILD_CFLAGS)
 mrgingham_pywrap_cplusplus_bridge.o: CCXXFLAGS += -fPIC
 mrgingham_pywrap.o: $(addsuffix .h,$(wildcard *.docstring))

=== debian/changelog ===
mrgingham (1.26-1build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 21 Oct 2025 17:46:10 +0000

mrgingham (1.26-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Wed, 19 Mar 2025 11:00:24 -0700

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,9 @@
  pkg-config,
  mrbuild,
  chrpath,
+# for "make install" to work. See
+#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080938
+ python3-setuptools,
  python3-all, python3-all-dev,
  perl,
  mawk,
@@ -15,8 +18,7 @@
 # for mrgingham-rotate-corners (its tests)
  vnlog (>= 1.33),
  python3-numpy
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
 Standards-Version: 3.9.8
 Homepage: https://github.com/dkogan/mrgingham/

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# Needed for cross-building:
#
#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=853881
#
# According to the report, debhelper 10 supports this already, but I'd like to
# be compatible with older distros for now, so I still set this manually
export PKG_CONFIG := $(DEB_HOST_GNU_TYPE)-pkg-config
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with python3

# I build everything, including the default python libraries
#
# And then I build the python libraries for all the available python versions,
# which could be more than just the default. The default one won't be rebuilt,
# because the build system will see it's done already
override_dh_auto_build:
	export VERSION=$(shell echo $(DEB_VERSION) | sed "s/-.*//");	\
	for v in `py3versions -s | sed s/python//g`; do			\
	  rm -f *pywrap*.o;						\
	  PYTHON_VERSION_FOR_EXTENSIONS=$$v dh_auto_build;		\
	done

# Similarly, I install everything, looping through all the available python
# versions, which could be more than just the default. All the non-python stuff
# will be installed multiple times, but it's the same files going to the same
# paths, so it hurts nothing
override_dh_auto_install:
	export VERSION=$(shell echo $(DEB_VERSION) | sed "s/-.*//");	\
	for v in `py3versions -s | sed s/python//g`; do			\
	  PYTHON_VERSION_FOR_EXTENSIONS=$$v dh_auto_install;		\
	done

override_dh_python3:
	dh_numpy3
	dh_python3

# don't compress docs
override_dh_compress:
	dh_compress -X.org -X.fig
